/* PARAMETERS AND INTERFACE FOR ARITHMETIC ENCODING AND DECODING ROUTINES.  */

#define Code_value_bits 16		/* Number of bits in a code value   */
typedef long code_value;		/* Type of an arithmetic code value */

#define Top_value (((long)1<<Code_value_bits)-1)      /* Largest code value */

#define First_qtr (Top_value/4+1)	/* Point after first quarter        */
#define Half	  (2*First_qtr)		/* Point after first half           */
#define Third_qtr (3*First_qtr)		/* Point after third quarter        */

#define Max_frequency 16383             /* Maximum allowed frequency count  */

void start_encoding (void);		/* Start encoding symbols */
void encode_symbol (int, int []);       /* Encode a symbol */
void done_encoding (void);		/* Finish with encoding */

void start_decoding (void);		/* Start decoding symbols */
int decode_symbol (int []);		/* Decode a symbol */
