/* MAINTAINENCE OF CUMULATIVE FREQUENCY TABLES. */

#include "arithmetic_coding.h"
#include "freq.h"


/* INITIALIZE TABLE OF CUMULATIVE FREQUENCIES TO ALL FREQUENCIES BEING ONE. */

void initialize_cum_freq (int nsym, int cum_freq[])
{
    int i;
    for (i = 0; i<=nsym; i++) 			/* Initialize cumulative    */
        cum_freq[i] = nsym-i;			/* frequencies, for counts  */
}						/* that are all one.        */


/* UPDATE CUMULATIVE FREQUENCY TABLE BY INCREMENTING COUNT FOR ONE SYMBOL.  */

void update_cum_freq (int sym, int nsym, int cum_freq[])
{
    int i;

    if (cum_freq[0]==Max_frequency) {		/* Halve frequencies if at  */
        int freq, ocum;				/* their maximum.           */
        ocum = 0;
        for (i = nsym-1; i>=0; i--) {		/* Halve all the counts,    */
            freq = cum_freq[i] - ocum;		/* keeping them non-zero    */
            ocum = cum_freq[i];
            cum_freq[i] = cum_freq[i+1] + (freq + 1) / 2;		
        }
    }

    for (i = sym-1; i>=0; i--)			/* Increment cumulative     */
        cum_freq[i] += 1;			/* frequencies.             */
}
