/* DECODER FOR SIMPLE ORDER-0 MODEL. */

#include <stdio.h>
#include "arithmetic_coding.h"
#include "freq.h"

#define No_of_symbols 257	/* 8-bit bytes plus EOF_symbol   */	   
#define EOF_symbol 257		/* Last symbol is end-of-file    */

int cum_freq[No_of_symbols+1];	/* Cumulative symbol frequencies */

int main(void)
{
    int i;

    start_inputing_bits();			/* Initialize modules.      */
    start_decoding();

    initialize_cum_freq(No_of_symbols,cum_freq);

    for (;;) {					/* Loop through characters. */
        int ch, sym;
        sym = decode_symbol(cum_freq);		/* Decode next symbol.      */
        if (sym==EOF_symbol) break;		/* Exit loop if EOF symbol. */
        ch = sym - 1;				/* Convert to character.    */
        putc(ch,stdout);			/* Write that character.    */
        update_cum_freq(sym,No_of_symbols,cum_freq); /* Increment sym count.*/
    }

    return 0;
}
