/* ENCODER FOR SIMPLE ORDER-0 MODEL. */

#include <stdio.h>
#include "arithmetic_coding.h"
#include "freq.h"

#define No_of_symbols 257	/* 8-bit bytes plus EOF_symbol   */	   
#define EOF_symbol 257		/* Last symbol is end-of-file    */

int cum_freq[No_of_symbols+1];	/* Cumulative symbol frequencies */

int main(void)
{
    start_outputing_bits();			/* Initialize modules.      */
    start_encoding();

    initialize_cum_freq(No_of_symbols,cum_freq);

    for (;;) {					/* Loop through characters. */
        int ch, sym;
        ch = getc(stdin);			/* Read the next character. */
        if (ch==EOF) break;			/* Exit loop on end-of-file.*/
        sym = ch + 1;				/* Symbols start at 1.      */
        encode_symbol(sym,cum_freq);		/* Encode that symbol.      */
        update_cum_freq(sym,No_of_symbols,cum_freq); /* Increment sym count.*/
    }

    encode_symbol(EOF_symbol,cum_freq);		/* Encode the EOF symbol.   */

    done_encoding();				/* Send the last few bits.  */
    done_outputing_bits();

    return 0;
}
